#include <adaption.hpp>
#include <algorithm>
#include <set>

#define CHGT_S2Y(s)   ((s)/(1.+(s)))
#define CHGT_Y2S(y)   ((y)/(1.-(y)))


/*
void adaption_t(const vector<double> & old_grid, const  vector<double> &estim,vector<double> & new_grid, const double threshold, const int  max_aspect_ratio)
{
  cout << "adaption_t called" << endl;
  int refineS;
  for(int j=0;j<old_grid.size()-1;j++)
    {
      refineS = int (estim[j]/threshold);
      refineS=Max(refineS,1);
      refineS=Min(refineS,max_aspect_ratio);
      for(int i=0; i<refineS;i++)
	new_grid.push_back(((refineS -i)*old_grid[j]+ i*old_grid[j+1])/refineS);
    }
  new_grid.push_back(old_grid[old_grid.size()-1]);
}



void adaption_t2(const vector<double> & old_grid, const  vector<double> &estim,vector<double> & new_grid, const double estim_factor, const int  max_aspect_ratio)
{
  cout << "adaption_t2 called" << endl;
  double  minestim=10000;
  int refinet;
  for(int i=0;i<estim.size();i++)
    if (estim[i]<minestim)
     minestim=estim[i];
  minestim *=estim_factor;
  for(int it=0;it<old_grid.size()-1;it++)
    {
      
      refinet = int (estim[it]/minestim);
      refinet=Min(refinet,max_aspect_ratio);
      refinet=Max(refinet,1);
      for(int i=0; i<refinet;i++)
       new_grid.push_back(((refinet -i)*old_grid[it]+ i*old_grid[it+1])/refinet);
    }
  new_grid.push_back(old_grid[old_grid.size()-1]);
}




void adaption_t2(const vector<double> & old_grid, const vector<vector<double> > &old_grid_S,  const vector<int> &old_change_grid, const  vector<double> &estim,vector<double> & new_grid, vector<vector<double> > &new_grid_S, vector<int> &new_change_grid,  vector<vector<double> > &new_step_S, const double estim_factor, const int  max_aspect_ratio)
{
  cout << "adaption_t2(2) called" << endl;
  double  minestim=10000;
  int refinet;
  for(int i=0;i<estim.size();i++)
    if (estim[i]<minestim)
     minestim=estim[i];
  minestim *=estim_factor;
  for(int it=0;it<old_grid.size()-1;it++)
    {
      
      refinet = int (estim[it]/minestim);
      refinet=Min(refinet,max_aspect_ratio);
      refinet=Max(refinet,1);
      for(int i=0; i<refinet;i++)
	new_grid.push_back(((refinet -i)*old_grid[it]+ i*old_grid[it+1])/refinet);
      new_change_grid.push_back(old_change_grid[it]);
      new_grid_S.push_back(old_grid_S[it]);
	
      for(int i=1; i<refinet;i++)
	{
	  new_change_grid.push_back(0);
	  new_grid_S.push_back(old_grid_S[it]);
	}
    }
  new_grid.push_back(old_grid[old_grid.size()-1]);
  new_change_grid.push_back(1);
  new_grid_S.push_back(old_grid_S[old_grid_S.size()-1]);
  new_step_S.resize( new_grid_S.size());
  for(int it=0;it<new_grid_S.size();it++)
    for(int j=0;j<new_grid_S[it].size()-1;j++)
      new_step_S[it].push_back(new_grid_S[it][j+1]-new_grid_S[it][j]);
  
}






void adaption_t3(const vector<double> & old_grid, const  vector<double> &estim,vector<double> & new_grid, const double estim_factor, const int  max_aspect_ratio)
{
  cout << "adaption_t3 called" << endl;
 double  minestim=10000;
 int refinet;
 for(int i=0;i<estim.size();i++)
   if (estim[i]<minestim)
     minestim=estim[i];
 minestim *=estim_factor;
 for(int it=0;it<old_grid.size()-1;it++)
   {
     if (estim[it]>minestim)
       {
	 refinet = int (estim[it]/minestim);
	 refinet=Min(refinet,max_aspect_ratio);
	 for(int i=0; i<refinet;i++)
	   new_grid.push_back(((refinet -i)*old_grid[it]+ i*old_grid[it+1])/refinet);
	 if(it==old_grid.size()-2)
	   new_grid.push_back(old_grid[old_grid.size()-1]);
       }
     else
       {
	 double sum=0;
	 int jt=it;
	 while (sum<minestim)
	   {
	     sum+=estim[jt];
	     jt++;
	     if (jt==old_grid.size()-1)
	       break;
	   }
	  new_grid.push_back(old_grid[jt]);
	 it=jt-1;
       }
   }

}


*/

void adaption_S(const vector<double> & old_grid, const  KN<double> &estim,vector<double> & new_grid, const double threshold, const int  max_aspect_ratio)
{
  int refineS;
  for(int j=0;j<old_grid.size()-1;j++)
    {
      refineS = int (estim(j)/threshold);
      refineS=Max(refineS,1);
      refineS=Min(refineS,max_aspect_ratio);
      for(int i=0; i<refineS;i++) {
	double d =  ((refineS -i)* CHGT_Y2S(old_grid[j])+ i* CHGT_Y2S(old_grid[j+1]))/refineS;
	new_grid.push_back(CHGT_S2Y(d));
      }
    }
  new_grid.push_back(old_grid[old_grid.size()-1]);
}


void adaption_S(const vector<double> & old_grid, const  KN<double> &estim,vector<double> & new_grid, const double maxestim, const double minestim,
const double reduction_factor,const int  max_aspect_ratio)
{
  int refineS;
  for(int j=0;j<old_grid.size()-1;j++)
    {
      refineS = int ((fabs(estim(j))-minestim)/(maxestim-minestim)*4* max_aspect_ratio+1 );
      refineS=Max(refineS,1);
      refineS=Min(refineS,max_aspect_ratio);
      for(int i=0; i<refineS;i++) {
	double d =  ((refineS -i)* CHGT_Y2S(old_grid[j])+ i* CHGT_Y2S(old_grid[j+1]))/refineS;
	new_grid.push_back(CHGT_S2Y(d));
      }
    }
  new_grid.push_back(old_grid[old_grid.size()-1]);
}


void adaption_S(const vector< vector<double> >& old_grid, const vector< KN<double> >&estim, vector< vector<double> >& new_grid, vector< vector<double> >& new_steps, vector<int> & change_grid,  const double threshold, const int  max_aspect_ratio)
{
  new_grid.resize( old_grid.size());
  new_steps.resize( old_grid.size());
  change_grid.resize(old_grid.size());
  for(int it=1;it<old_grid.size();it++)
    adaption_S(old_grid[it],estim[it],new_grid[it],threshold,max_aspect_ratio);
  new_grid[0]= new_grid[1]; 
 for(int it=0;it<new_grid.size();it++)
   {
     for(int j=0;j<new_grid[it].size()-1;j++)
       new_steps[it].push_back(new_grid[it][j+1]-new_grid[it][j]);
     change_grid[it]=1;
   }
}







void adaption_tS(const vector<double> & old_t_grid, const  vector<double> &estim,vector<double> & new_t_grid, const double estim_factor, const int  max_aspect_ratio,const vector< vector<double> >& old_S_grid, const vector<int> & old_change_grid, const vector< vector<double> >& old_steps,
		 const vector< KN<double> >&estim_S, vector< vector<double> >& new_S_grid, vector< vector<double> >& new_steps, vector<int> & change_grid,  const double threshold, const int  max_aspect_ratio_S, const vector<double> & global_estim_S, int which_adapt)
{
  double  minestim=10000;
  double  maxestim=0;
  int refinet;
  for(int i=0;i<estim.size();i++)
   {
     if (estim[i]<minestim)
      minestim=estim[i];
     if (estim[i]>maxestim)
       maxestim=estim[i];
   }
  cout << "minestim="<<minestim<<" maxestim="<<maxestim<<endl;


  /*
  if (maxestim> 10* minestim)
    minestim+=(maxestim-minestim)/50;
  else
    minestim *=estim_factor;
  */
  double  maxestimS=0;
  double  minestimS=10000;
  
  for(int i=0;i<estim_S.size();i++)
    for(int j=0;j<estim_S[i].N();j++)
      {
	if (abs(estim_S[i](j))>maxestimS)
	  maxestimS=abs(estim_S[i](j));
	if (abs(estim_S[i](j))<minestimS)
	  minestimS=abs(estim_S[i](j));
      }
  cout << "maxestimS="<<maxestimS<<endl;
  cout << "minestimS="<<minestimS<<endl;




  set<double,less<double> > est;
  for(int i=0;i<estim_S.size();i++)
    for(int j=0;j<estim_S[i].N();j++)
      est.insert(abs(estim_S[i](j)));
  set<double, less<double > >::reverse_iterator rit;
  int i=0;
  for(rit=est.rbegin();i<10;rit++,i++)
    maxestimS=*rit;
  cout << "maxestimS="<<maxestimS<<endl;
  /*
    maxestimS/=10;
  */

  for(int it=0;it<old_t_grid.size()-1;it++)
    {
      
      if((which_adapt==0) || ((which_adapt==2) &&(estim[it]>=global_estim_S[it])))
	{
	  cout << "time refinement at it="<<it<<endl;
	  refinet = int (1+(estim[it]-minestim)/(maxestim-minestim)*max_aspect_ratio);
	  refinet=Min(refinet,max_aspect_ratio);
	  refinet=Max(refinet,1);
	  for(int i=0; i<refinet;i++)
	    {
	      new_t_grid.push_back(((refinet -i)*old_t_grid[it]+ i*old_t_grid[it+1])/refinet);
	      new_S_grid.push_back(old_S_grid[it]);
	      //	      new_steps.push_back(old_steps[it]);
	      if (i==0)
		{
		  change_grid.push_back(old_change_grid[it]);
		}
	      else
		change_grid.push_back(0);
	    }
	  cout << "time refinement at it="<<it<<"done"<< endl;
	}
      else if((which_adapt==1) || ((which_adapt==2) &&(estim[it]<global_estim_S[it])))
	{
	  if(it==0)
	    {
	      cout << "S refinement at it="<<it<<endl;
	      new_t_grid.push_back(old_t_grid[it]);
	      change_grid.push_back(1);
	      new_S_grid.push_back(old_S_grid[it]);
	      cout << "S refinement at it="<<it<<"done"<< endl;
	    }
	  else
	    if(it>0)
	      {
		cout << "S refinement at it="<<it<<endl;
		new_t_grid.push_back(old_t_grid[it]);
		change_grid.push_back(1);
		vector<double> aux_grid;
		vector<double> aux_steps;
#if 0
		adaption_S(old_S_grid[it],estim_S[it],aux_grid,  maxestimS,minestimS, threshold,max_aspect_ratio_S);
		new_S_grid.push_back(aux_grid);
#else
		//adaption_S(old_S_grid[it],estim_S[it],aux_grid,  maxestimS,minestimS, threshold,max_aspect_ratio_S);
		new_S_grid.push_back(old_S_grid[it]);
#endif
		cout << "S refinement at it="<<it<<"done"<< endl;
	      }	  
	}
      else 
	{
	  cout <<"this case is not possible"<<endl;
	  return;
	}
    }//it
    
  new_S_grid[0]=new_S_grid[1];
  new_t_grid.push_back(old_t_grid[old_t_grid.size()-1]);
  new_S_grid.push_back(new_S_grid[new_t_grid.size()-2]);
  change_grid.push_back(0);
  new_steps.resize(new_S_grid.size());
  for(int it=0;it<new_S_grid.size();it++)
    {
      for(int j=0;j<new_S_grid[it].size()-1;j++)
	new_steps[it].push_back(new_S_grid[it][j+1]-new_S_grid[it][j]);

    }
  int number_of_nodes=0;
 for(int it=0;it<new_S_grid.size();it++)
   for(int j=0;j<new_S_grid[it].size()-1;j++)
     number_of_nodes++;
 cout<< "number of nodes ="<< number_of_nodes <<endl;
	
}




